//
//  Game.h
//  NumbersTo1
//
//  Created by Micah Holden on 2/19/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MyButton.h"
#import "Button.h"

@interface Game : NSObject <NSApplicationDelegate>
{
	IBOutlet id colors;
	IBOutlet id dimMat;
	IBOutlet id view;
	NSMutableArray* buttons,*buttonData;
	NSUndoManager* undoMoves;
	int dim,moves,level,zrow,zcol,shuffleCount;
	BOOL colorsOn,shuffling;
	NSUserDefaults* savedLevels;
}
#pragma mark -
#pragma mark Buttons Pressed
- (void)buttonsPressed:(id)sender;
- (IBAction)shuffle:(id)sender;
- (IBAction)undo:(id)sender;
- (IBAction)color:(id)sender;
- (IBAction)restart:(id)sender;
- (IBAction)dimPressed:(id)sender;
- (IBAction)resetLevels:(id)sender;
#pragma mark -
#pragma mark Update View
- (void)dimChangeTo:(int)dimension;
- (void)fixColors;
- (void)setButText;
#pragma mark -
#pragma mark Level Manipulation
- (void)saveLevels;
- (int)getLevels;
- (void)setLevel:(int)lev;
- (NSString*) pathForDataFile;
- (void)saveDataToDisk;
- (void)loadDataFromDisk;
#pragma mark -
#pragma mark Board Setup
- (BOOL)shuffleButtons;
- (void)resetButtons;
#pragma mark -
#pragma mark Moveing Buttons
- (BOOL)checkMoveRow:(MyButton*)button;
- (BOOL)checkMoveCol:(MyButton*)button;
- (BOOL)moveRow:(MyButton*)button;
- (BOOL)moveCol:(MyButton*)button;
#pragma mark -
#pragma mark Undo Check for Winner
- (void)undoMove:(MyButton*)button;
- (BOOL)checkWin;
@property (retain) id colors;
@property (retain) id dimMat;
@property (retain) id view;
@property (retain) NSUndoManager* undoMoves;
@property (retain) NSUserDefaults* savedLevels;
@end
